#include "AppleEventUtilities.h"
#include "AERegistry.h"
#include "AEObjects.h"
#include "FinderRegistry.h"
#include "Exceptions.h"


void FindPSNbyTypeAndSig(ProcessSerialNumber* psn, OSType type, OSType sig);
TDescriptor GetAddressOfFinder(void);
TDescriptor MakeSpecifierForFrontWindow(void);
TDescriptor MakeSpecifierForIndexedItem(DescType desiredClass, long index, TDescriptor ofSpecifier);
TDescriptor MakeSpecifierForPropertyOfSpecifier(DescType property, TDescriptor ofSpecifier);
long CountItemsInContainer(DescType desiredClass, TDescriptor inContainer, TDescriptor target);




void GetFrontWindowInfo(long *num, Point *windPosition, Rect *windRect, long *viewType);
OSErr GetFinderItemInfo(short item, Handle *theBits, Handle *theMaskBits, Point *position);
OSErr GatherFinderInfo(short maxItems);


